﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'########## This Class is used for the calls to the IISAPI ##########
'Es: 
'Dim IIS as IISApiCall

'Sub CallWebApi
	'IIS.Initialize("Root","page to execute","QuesryString", "CustomKeyHeader","CustomValueHeader","JobExec", "SourceTarget")
'End Sub
'IISApiCall_Exec(JobName As String)
'	Dim map1 As Map
	
'	If IIS.IsInError = False Then
'		map1.Initialize
'		map1 = IIS.GiveMeData
		
'		Select Case JobName
'			Case "JobExec"
				
'		End Select
'	End if
'End Sub

Sub Class_Globals
	Dim SourceTarget As Object
	Private Errore As Byte
	Private Data As Map
	Dim Num_tentativi As Byte
	
	
	Dim rootCache As String
	Dim scriptCache As String
	Dim QueryCache As String
	'Dim CustomKeyHeaderCache As String
	'Dim CustomValueHeaderCache As String
	Private  CustomHeaderCache As Map
	
	Private RxHeader As Map 'header rx from WebApi
	
	Private IIS_Busy As Boolean = False
End Sub

'##################################################################
'Execution of a webrequest in POST mode
'
'When call will be execute a sub Call "IISApiCall_Exec" will be execute
'in the SourceTarget
Public Sub Initialize (root As String, script As String, Query As String, CustomHeader As Map, JobName As String, SourceTarget1 As Object)
	
	Dim job As HttpJob

	SourceTarget = SourceTarget1
	job.Initialize(JobName, Me)
	rootCache = root
	scriptCache = script
	QueryCache = Query
	'CustomKeyHeaderCache = CustomKeyHeader
	'CustomValueHeaderCache = CustomValueHeader
	CustomHeaderCache = CustomHeader
	
	If IIS_Busy = False Then
		ExecuteQuery(job, rootCache, scriptCache, QueryCache, CustomHeaderCache)
	End If
End Sub

'#####################################################################
Sub ExecuteQuery(job As HttpJob, root As String, script As String, Query As String, CustomHeader As Map)
		
	IIS_Busy = True
	
	job.PostString(root & script , Query)
	job.GetRequest.Timeout = 25000

	'add custom heather if exist
	If CustomHeader.IsInitialized Then
		If CustomHeader.Size > 0 Then
			#If b4a
				Dim i As Byte
				For i = 0 To CustomHeader.Size - 1
					job.GetRequest.SetHeader(CustomHeader.GetKeyAt(i),CustomHeader.GetValueAt(i))
					'job.GetRequest.SetHeader(CustomHeader.get
				Next 
			#end if
			#If b4i
				For Each key As String In CustomHeader.Keys
					job.GetRequest.SetHeader(key, CustomHeader.Get(key))
				Next
			#end if
		End If
	End If

End Sub

'########## function active when the http result as a success ##########
Sub JobDone (jobName As HttpJob)

	'Dim tm As Cls_ToastMessage

	If jobName.Success = True Then
		
		Errore = 0
		GetData(jobName.GetString)

		'load last rxHeader
		RxHeader = jobName.Response.GetHeaders

		If Errore  = 1 Then
			RetryExecuteQuery(jobName)
		End If
	Else
		'tm.Initialize("Job fail" & jobName.JobName,False)
		Log("ISS JOB Error: " & jobName.ErrorMessage)
'		ToastMessageShow("Error: " & job.ErrorMessage, True)
		Errore = 1
		RetryExecuteQuery(jobName)
	End If
	
	CallSub2(SourceTarget, "IISAPICall" & "_Exec" ,jobName.JobName)
	
	jobName.Release
	
	IIS_Busy = False
End Sub

'##################################################################
Sub RetryExecuteQuery(jobName As HttpJob)
	
	Num_tentativi = Num_tentativi + 1
	
	'GLB.DebugToastMessage("IIS Tentativo: " & Num_tentativi)
	'try to connect 
	If Num_tentativi < 2 Then
		'retry to connect
		ExecuteQuery(jobName, rootCache, scriptCache, QueryCache, CustomHeaderCache)
	Else
		'comunication error
		Num_tentativi = 0
		'Dim Tm As Cls_ToastMessage
		'Tm.Initialize(GLB.Translations.GetDefault(TRANS.TXT_SERVER_OFFLINE,"Unable to connect to the Server"),False)
	End If
	
End Sub

'########## It excract 1 file Map with the data section of the json ##########
Sub GetData (Result As String)
	
	Dim Json As JSONParser
	Dim Map1 As Map
	Try
		Log("WebApi_RxData: = " & Result)
		Json.Initialize(Result)
		Map1 = Json.NextObject
		Data = Map1.Get("Data")
		If Map1.ContainsKey("Version") Then
			Log( Map1.Get("Version"))
			
			Dim a As JSONGenerator
			
			a.Initialize(Map1)
			
			Log(a.ToString)
				
		End If
		Dim MapError As Map = Map1.Get("NotTrappedError")
	Catch
		Data.Initialize
		'set receive data error to decode
		Errore = 2
		IIS_Busy = False
	End Try
	
	Try
		If MapError.IsInitialized Then
			Dim MapNotTrapErr As Map = MapError.Get("Error")
			If MapNotTrapErr <> Null Then
				If MapNotTrapErr.IsInitialized Then
					Log("WebAPI Error1: " & Map1.Get("NotAuthorized"))
					Log("WebAPI Error2: " & Map1.Get("NotTrappedError"))
					'set generic error type
					Errore = 1
						
					Dim NotTrapErr As Map
					NotTrapErr = Map1.Get("NotTrappedError")
					'not trapped error catching and visualization

				End If
			End If
		End If
	Catch
		'Tm.Initialize("IIS Error decode NotTrapped",False)
		IIS_Busy = False
	End Try
	
	Try
		'check if there's a version compatibility error
		If Map1.Get("NotAuthorizedVersion") <> Null Then
			If Map1.Get("NotAuthorizedVersion") = True Then
				Errore = 4
			End If
		End If
	Catch
		Log("IIS Error Compatibility version")
		IIS_Busy = False
	End Try
	
	IIS_Busy = False
End Sub

'########## from the outside of the class it return the resul of the call ##########
Sub GiveMeData As Map

	Return Data
	
End Sub

'##################################################################
'return true if webapi not respond or respond with invalid data
Sub IsInError As Boolean
	Return Errore > 0
End Sub

'##################################################################
'return true if service is busy waiting and anwer
Sub IsBusy As Boolean 
	Return IIS_Busy
End Sub

'##################################################################
'set busy IIS as false
Sub SetBusyFalse 
	IIS_Busy = False
End Sub

'##################################################################
'return Value of the request Key in the header
Sub GetHeaderKeyValue(Key As String) As String
	
	Dim result As String = ""
	
	If RxHeader.IsInitialized Then
		result = RxHeader.GetDefault(Key,"")
	End If
	
	Return result
	
End Sub

#if B4i
	Private Sub GetHeaders(job As HttpJob) As Map
		
		
	End Sub
#end if